# Combinatorics

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](http://juliamath.github.io/Combinatorics.jl/)
[![deps](https://juliahub.com/docs/General/Combinatorics/stable/deps.svg)](https://juliahub.com/ui/Packages/General/Combinatorics?t=2)
[![CI](https://github.com/JuliaMath/Combinatorics.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaMath/Combinatorics.jl/actions/workflows/CI.yml)
[![Coverage Status](https://coveralls.io/repos/github/JuliaMath/Combinatorics.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaMath/Combinatorics.jl?branch=master)
[![codecov](https://codecov.io/gh/JuliaMath/Combinatorics.jl/graph/badge.svg?token=ov65P61lvZ)](https://codecov.io/gh/JuliaMath/Combinatorics.jl)

A combinatorics library for Julia, focusing mostly (as of now) on enumerative
combinatorics and permutations.  As overflows are expected even for low values,
most of the functions always return `BigInt`, and are marked as such below.

## Installation

In the Julia REPL, type `]add Combinatorics` and then `using Combinatorics` to access the below functions.

## Documentation

Go to http://juliamath.github.io/Combinatorics.jl/ to see the list of exported functions and their meanings.

# Combinatorics

[![CI](https://github.com/JuliaMath/Combinatorics.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaMath/Combinatorics.jl/actions/workflows/CI.yml)
[![Coverage Status](https://coveralls.io/repos/github/JuliaMath/Combinatorics.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaMath/Combinatorics.jl?branch=master)
[![codecov](https://codecov.io/gh/JuliaMath/Combinatorics.jl/graph/badge.svg?token=ov65P61lvZ)](https://codecov.io/gh/JuliaMath/Combinatorics.jl)

A combinatorics library for Julia, focusing mostly (as of now) on enumerative
combinatorics and permutations.  As overflows are expected even for low values,
most of the functions always return `BigInt`, and are marked as such below.

## Installation

In the Julia REPL, type `]add Combinatorics` and then `using Combinatorics` to access the below functions.

## Usage

This library provides the following functions:
 - `bellnum(n)`: returns the n-th Bell number; always returns a `BigInt`;
 - `catalannum(n)`: returns the n-th Catalan number; always returns a `BigInt`;
 - `lobbnum(m,n)`: returns the generalised Catalan number at `m` and `n`; always returns a `BigInt`;
 - `narayana(n,k)`: returns the general Narayana number at any given `n` and `k`; always returns a `BigInt`;
 - `combinations(a,n)`: returns all combinations of `n` elements of indexable object `a`;
 - `combinations(a)`: returns combinations of all order by chaining calls to `combinations(a,n)`;
 - `derangement(n)`/`subfactorial(n)`: returns the number of permutations of n with no fixed points; always returns a `BigInt`;
 - `partialderangement(n, k)`: returns the number of permutations of n with exactly k fixed points; always returns a `BigInt`;
 - `doublefactorial(n)`: returns the double factorial n!!; always returns a `BigInt`;
 - `fibonaccinum(n)`: the n-th Fibonacci number; always returns a `BigInt`;
 - `hyperfactorial(n)`: the n-th hyperfactorial, i.e. prod([i^i for i = 2:n]; always returns a `BigInt`;
 - `integer_partitions(n)`: returns a `Vector{Int}` consisting of the partitions of the number `n`.
 - `jacobisymbol(a,b)`: returns the Jacobi symbol (a/b);
 - `lassallenum(n)`: returns the nth Lassalle number A<sub>n</sub> defined in [arXiv:1009.4225](http://arxiv.org/abs/1009.4225) ([OEIS A180874](http://oeis.org/A180874)); always returns a `BigInt`;
 - `legendresymbol(a,p)`: returns the Legendre symbol (a/p);
 - `lucasnum(n)`: the n-th Lucas number; always returns a `BigInt`;
 - `multifactorial(n)`: returns the m-multifactorial n(!^m); always returns a `BigInt`;
 - `multinomial(k...)`: receives a tuple of `k_1, ..., k_n` and calculates the multinomial coefficient `(n k)`, where `n = sum(k)`; returns a `BigInt` only if given a `BigInt`;
 - `multiexponents(m,n)`: returns the exponents in the multinomial expansion (x₁ + x₂ + ... + xₘ)ⁿ;
 - `primorial(n)`: returns the product of all positive prime numbers <= n; always returns a `BigInt`;
 - `powerset(a)`: returns all subsets of an indexable object `a`
 - `stirlings1(n, k, signed=false)`: returns the `(n,k)`-th Stirling number of the first kind; the number is signed if `signed` is true; returns a `BigInt` only if given a `BigInt`.
 - `stirlings2(n, k)`: returns the `(n,k)`-th Stirling number of the second kind; returns a `BigInt` only if given a `BigInt`.
 - `nthperm(a, k)`: Compute the `k`th lexicographic permutation of the vector `a`.
 - `permutations(a)`: Generate all permutations of an indexable object `a` in lexicographic order.

Young diagrams
--------------
Limited support for working with Young diagrams is provided.

- `partitionsequence(a)`: computes partition sequence for an integer partition `a`
- `x = a \ b` creates the skew diagram for partitions (tuples) `a`, `b`
- `isrimhook(x)`: checks if skew diagram `x` is a rim hook
- `leglength(x)`: computes leg length of rim hook `x`
- `character(a, b)`: computes character the partition `b` in the `a`th irrep of Sn

@testset "youngdiagrams" begin
    let λ = Partition([5, 4, 2, 2]), μ = Partition([2, 1])
        @test λ \ μ == SkewDiagram(λ, μ)
        @test leglength(λ, μ) == leglength(λ \ μ) == 3
    end
    @test leglength(Partition(Int[]), Partition(Int[])) == -1

    @test isrimhook(Partition([4, 3, 2]), Partition([2, 2, 2]))
    @test !isrimhook(Partition([4, 3, 2]), Partition([2, 2, 1]))
    @test !isrimhook(Partition([4, 3, 2]), Partition([1, 1]))

    let λ = Partition([5, 4, 2, 1]), μ = Partition([4, 3, 2, 2, 1])
        @test partitionsequence(λ) == [1, 0, 1, 0, 1, 1, 0, 1, 0]
        @test character(λ, μ) == 0
    end

    let λ = μ = Partition([1])
        @test leglength(λ, μ) == -1
        @test character(λ, μ) == 1
    end

end

module Combinatorics

include("numbers.jl")
include("factorials.jl")
include("combinations.jl")
include("permutations.jl")
include("partitions.jl")
include("multinomials.jl")
include("youngdiagrams.jl")

end #module

@testset "factorials" begin
    @test factorial(7, 3) == 7 * 6 * 5 * 4
    @test_throws DomainError factorial(3, 7)
    @test_throws DomainError factorial(-3, -7)
    @test_throws DomainError factorial(-7, -3)
    @test_throws DomainError factorial(big"3", big"7")
    @test_throws DomainError factorial(big"-3", big"7")
    @test_throws DomainError factorial(big"3", big"-7")
    #JuliaLang/julia#9943
    @test factorial(big(100), (80)) == 1303995018204712451095685346159820800000
    #JuliaLang/julia#9950
    @test_throws OverflowError factorial(1000, 80)

    # derangement
    @test derangement(4) == subfactorial(4) == 9
    @test derangement(0) == 1
    @test derangement(1) == 0
    @test derangement(24) == parse(BigInt, "228250211305338670494289")
    @test_throws DomainError derangement(-1)

    # partialderangement
    @test partialderangement(7, 3) == 315
    @test_throws DomainError partialderangement(8, 9)
    @test_throws DomainError partialderangement(-8, 0)

    # doublefactorial
    @test doublefactorial(70) == parse(BigInt, "355044260642859198243475901411974413130137600000000")
    @test_throws DomainError doublefactorial(-1)

    # hyperfactorial
    @test hyperfactorial(8) == parse(BigInt, "55696437941726556979200000")
    @test hyperfactorial(0) == parse(BigInt, "1")
    @test hyperfactorial(1) == parse(BigInt, "1")
    @test hyperfactorial(2) == parse(BigInt, "4")

    # multifactorial
    @test multifactorial(40, 2) == doublefactorial(40)
    @test_throws DomainError multifactorial(-1, 1)

    @testset "multinomial" begin
        # > For k=0,1, the multinomial coefficient is defined to be 1
        # https://dlmf.nist.gov/26.4#i.p1
        @test multinomial() == 1
        @test multinomial(0) == 1

        @test multinomial(1, 4, 4, 2) == 34650
        # wolfram:  Multinomial[10, 10, 10, 5]
        @test multinomial(10, 10, 10, 5) == 1_802_031_190_366_286_880

        # checked_mul overflowed for type Int64
        @test_throws OverflowError multinomial(10, 10, 10, 6)
        @test_throws OverflowError multinomial(10, 10, 10, 10)
        # binomial(200, 100) overflows
        @test_throws OverflowError multinomial(100, 100)  
    end

    # primorial
    @test primorial(17) == 510510
    @test_throws DomainError primorial(-1)

end

export combinations,
       CoolLexCombinations,
       multiset_combinations,
       with_replacement_combinations,
       powerset

#The Combinations iterator
struct Combinations
    n::Int
    t::Int
end

@inline function Base.iterate(c::Combinations, s = [min(c.t - 1, i) for i in 1:c.t])
    if c.t == 0 # special case to generate 1 result for t==0
        isempty(s) && return (s, [1])
        return
    end
    for i in c.t:-1:1
        s[i] += 1
        if s[i] > (c.n - (c.t - i))
            continue
        end
        for j in i+1:c.t
            s[j] = s[j-1] + 1
        end
        break
    end
    s[1] > c.n - c.t + 1 && return
    (s, s)
end

Base.length(c::Combinations) = binomial(c.n, c.t)

Base.eltype(::Type{Combinations}) = Vector{Int}

"""
    combinations(a, n)

Generate all combinations of `n` elements from an indexable object `a`. Because the number
of combinations can be very large, this function returns an iterator object.
Use `collect(combinations(a, n))` to get an array of all combinations.
"""
function combinations(a, t::Integer)
    if t < 0
        # generate 0 combinations for negative argument
        t = length(a) + 1
    end
    reorder(c) = [a[ci] for ci in c]
    (reorder(c) for c in Combinations(length(a), t))
end


"""
    combinations(a)

Generate combinations of the elements of `a` of all orders. Chaining of order iterators
is eager, but the sequence at each order is lazy.
"""
combinations(a) = Iterators.flatten([combinations(a, k) for k = 1:length(a)])



# cool-lex combinations iterator

"""
    CoolLexCombinations

Produce ``(n,k)``-combinations in cool-lex order.

# Reference

Ruskey, F., & Williams, A. (2009). The coolest way to generate combinations.
*Discrete Mathematics*, 309(17), 5305-5320.
"""
struct CoolLexCombinations
    n::Int
    t::Int
end

struct CoolLexIterState{T<:Integer}
    R0::T
    R1::T
    R2::T
    R3::T
end

function Base.iterate(C::CoolLexCombinations)
    if C.n < 0
        throw(DomainError(C.n))
    end
    if C.t ≤ 0
        throw(DomainError(C.t))
    end

    #What integer size should I use?
    if C.n < 8sizeof(Int)
        T = Int
    else
        T = BigInt
    end

    state = CoolLexIterState{T}(0, 0, T(1) << C.n, (T(1) << C.t) - 1)
    iterate(C, state)
end

function Base.iterate(C::CoolLexCombinations, S::CoolLexIterState)
    (S.R3 & S.R2 != 0) && return

    R0 = S.R0
    R1 = S.R1
    R2 = S.R2
    R3 = S.R3

    R0 = R3 & (R3 + 1)
    R1 = xor(R0, R0 - 1)
    R0 = R1 + 1
    R1 &= R3
    R0 = max((R0 & R3) - 1, 0)
    R3 += R1 - R0

    _cool_lex_visit(S.R3), CoolLexIterState(R0, R1, R2, R3)
end

#Converts an integer bit pattern X into a subset
#If X & 2^k == 1, then k is in the subset
function _cool_lex_visit(X::Integer)
    subset = Int[]
    n = 1
    while X != 0
        X & 1 == 1 && push!(subset, n)
        X >>= 1
        n += 1
    end
    subset
end

Base.length(C::CoolLexCombinations) = max(0, binomial(C.n, C.t))


struct MultiSetCombinations{T}
    m::T
    f::Vector{Int}
    t::Int
    ref::Vector{Int}
end

Base.eltype(::Type{MultiSetCombinations{T}}) where {T} = Vector{eltype(T)}

function Base.length(c::MultiSetCombinations)
    t = c.t
    if t > length(c.ref)
        return 0
    end
    p = [1; zeros(Int, t)]
    for i in 1:length(c.f)
        f = c.f[i]
        if i == 1
            for j in 1:min(f, t)
                p[j+1] = 1
            end
        else
            for j in t:-1:1
                p[j+1] = sum(p[max(1,j+1-f):(j+1)])
            end
        end
    end
    return p[t+1]
end

function multiset_combinations(m, f::Vector{<:Integer}, t::Integer)
    length(m) == length(f) || error("Lengths of m and f are not the same.")
    ref = length(f) > 0 ? vcat([[i for j in 1:f[i] ] for i in 1:length(f)]...) : Int[]
    if t < 0
        t = length(ref) + 1
    end
    MultiSetCombinations(m, f, t, ref)
end

"""
    multiset_combinations(a, t)

Generate all combinations of size `t` from an array `a` with possibly duplicated elements.
"""
function multiset_combinations(a, t::Integer)
    m = unique(collect(a))
    f = Int[sum([c == x for c in a]) for x in m]
    multiset_combinations(m, f, t)
end

function Base.iterate(c::MultiSetCombinations, s = c.ref)
    ((!isempty(s) && max(s[1], c.t) > length(c.ref)) || (isempty(s) && c.t > 0)) && return

    ref = c.ref
    n = length(ref)
    t = c.t
    changed = false
    comb = [c.m[s[i]] for i in 1:t]
    if t > 0
        s = copy(s)
        for i in t:-1:1
            if s[i] < ref[i + (n - t)]
                j = 1
                while ref[j] <= s[i]
                    j += 1
                end
                s[i] = ref[j]
                for l in (i+1):t
                    s[l] = ref[j+=1]
                end
                changed = true
                break
            end
        end
        !changed && (s[1] = n+1)
    else
        s = [n+1]
    end
    (comb, s)
end

struct WithReplacementCombinations{T}
    a::T
    t::Int
end

Base.eltype(::Type{WithReplacementCombinations{T}}) where {T} = Vector{eltype(T)}

Base.length(c::WithReplacementCombinations) = binomial(length(c.a) + c.t - 1, c.t)

"""
    with_replacement_combinations(a, t)

Generate all combinations with replacement of size `t` from an array `a`.
"""
with_replacement_combinations(a, t::Integer) = WithReplacementCombinations(a, t)

function Base.iterate(c::WithReplacementCombinations, s = [1 for i in 1:c.t])
    (!isempty(s) && s[1] > length(c.a) || c.t < 0) && return

    n = length(c.a)
    t = c.t
    comb = [c.a[si] for si in s]
    if t > 0
        s = copy(s)
        changed = false
        for i in t:-1:1
            if s[i] < n
                s[i] += 1
                for j in (i+1):t
                    s[j] = s[i]
                end
                changed = true
                break
            end
        end
        !changed && (s[1] = n+1)
    else
        s = [n+1]
    end
    (comb, s)
end

## Power set

"""
    powerset(a, min=0, max=length(a))

Generate all subsets of an indexable object `a` including the empty set, with cardinality
bounded by `min` and `max`. Because the number of subsets can be very large, this function
returns an iterator object. Use `collect(powerset(a, min, max))` to get an array of all
subsets.
"""
function powerset(a, min::Integer=0, max::Integer=length(a))
    itrs = [combinations(a, k) for k = min:max]
    min < 1 && append!(itrs, eltype(a)[])
    Iterators.flatten(itrs)
end

#Partitions

export
    integer_partitions,
    ncpartitions,
    partitions,
    prevprod
    #nextprod,


#integer partitions

struct IntegerPartitions
    n::Int
end

Base.length(p::IntegerPartitions) = npartitions(p.n)
Base.eltype(p::IntegerPartitions) = Vector{Int}

function Base.iterate(p::IntegerPartitions, xs = Int[])
    length(xs) == p.n && return
    xs = nextpartition(p.n,xs)
    (xs, xs)
end

"""
    partitions(n)

Generate all integer arrays that sum to `n`. Because the number of partitions can be very
large, this function returns an iterator object. Use `collect(partitions(n))` to get an
array of all partitions. The number of partitions to generate can be efficiently computed
using `length(partitions(n))`.
"""
partitions(n::Integer) = IntegerPartitions(n)



function nextpartition(n, as)
    isempty(as) && return Int[n]

    xs = similar(as, 0)
    sizehint!(xs, length(as) + 1)

    for i = 1:length(as)-1
        if as[i+1] == 1
            x = as[i]-1
            push!(xs, x)
            n -= x
            while n > x
                push!(xs, x)
                n -= x
            end
            push!(xs, n)

            return xs
        end
        push!(xs, as[i])
        n -= as[i]
    end
    push!(xs, as[end]-1)
    push!(xs, 1)

    xs
end

let _npartitions = Dict{Int,Int}()
    global npartitions
    function npartitions(n::Int)
        if n < 0
            0
        elseif n < 2
            1
        elseif (np = get(_npartitions, n, 0)) > 0
            np
        else
            np = 0
            sgn = 1
            for k = 1:n
                np += sgn * (npartitions(n - (k*(3k-1)) >> 1) + npartitions(n - (k*(3k+1)) >> 1))
                sgn = -sgn
            end
            _npartitions[n] = np
        end
    end
end

# Algorithm H from TAoCP 7.2.1.4
# Partition n into m parts
# in colex order (lexicographic by reflected sequence)

struct FixedPartitions
    n::Int
    m::Int
end

Base.length(f::FixedPartitions) = npartitions(f.n,f.m)
Base.eltype(f::FixedPartitions) = Vector{Int}

"""
    partitions(n, m)

Generate all arrays of `m` integers that sum to `n`. Because the number of partitions can
be very large, this function returns an iterator object. Use `collect(partitions(n, m))` to
get an array of all partitions. The number of partitions to generate can be efficiently
computed using `length(partitions(n, m))`.
"""
partitions(n::Integer, m::Integer) =
    n >= 1 && m >= 1 ?
        FixedPartitions(n, m) :
        throw(DomainError((n, m), "n and m must be positive"))

function Base.iterate(f::FixedPartitions, s::Vector{Int} = Int[])
    f.m <= f.n || return
    if !isempty(s)
        (f.m == 1 || s[1]-1 <= s[end]) && return
    end

    xs = nextfixedpartition(f.n,f.m,s)
    (xs, xs)
end

function nextfixedpartition(n, m, bs)
    as = copy(bs)
    if isempty(as)
        # First iteration
        as = ones(Int, m); as[1] = n - m + 1
    elseif as[2] < as[1]-1
        # Most common iteration
        as[1] -= 1
        as[2] += 1
    else
        # Iterate
        j = 0
        s = as[1]+as[2]-1
        for jj = 3:m # TODO: use `for outer j = ...` on 0.7
            j = jj
            as[jj] < as[1]-1 && break
            s += as[jj]
        end
        x = as[j] += 1
        for k = j-1:-1:2
            as[k] = x
            s -= x
        end
        as[1] = s
    end

    return as
end

let _nipartitions = Dict{Tuple{Int,Int},Int}()
    global npartitions
    function npartitions(n::Int, m::Int)
        if n < m || m == 0
            0
        elseif n == m
            1
        elseif (np = get(_nipartitions, (n,m), 0)) > 0
            np
        else
            _nipartitions[(n, m)] = npartitions(n-1, m-1) + npartitions(n-m, m)
        end
    end
end

# Algorithm H from TAoCP 7.2.1.5
# Set partitions

struct SetPartitions{T<:AbstractVector}
    s::T
end

Base.length(p::SetPartitions) = nsetpartitions(length(p.s))
Base.eltype(p::SetPartitions) = Vector{Vector{eltype(p.s)}}

"""
    partitions(s::AbstractVector)

Generate all set partitions of the elements of an array `s`, represented as arrays of
arrays. Because the number of partitions can be very large, this function returns an
iterator object. Use `collect(partitions(s))` to get an array of all partitions. The
number of partitions to generate can be efficiently computed using
`length(partitions(s))`.
"""
partitions(s::AbstractVector) = SetPartitions(s)

function Base.iterate(p::SetPartitions)
    n = length(p.s)
    iterate(p, (zeros(Int32, n), ones(Int32, n-1), n, 1))
end
function Base.iterate(p::SetPartitions, s)
    s[1][1] > 0 && return
    nextsetpartition(p.s, s...)
end

function nextsetpartition(s::AbstractVector, a, b, n, m)
    function makeparts(s, a, m)
        temp = [similar(s, 0) for k = 0:m]
        for i = 1:n
            push!(temp[a[i]+1], s[i])
        end
        filter!(!isempty, temp)
    end

    if isempty(s);  return ([s], (eltype(a)[1], eltype(b)[], n, 1));  end

    part = makeparts(s,a,m)

    if a[end] != m
        a[end] += 1
    else
        j = 0
        for jj = n-1:-1:1
            j = jj
            a[jj] == b[jj] || break
        end
        a[j] += 1
        m = Int(b[j]) + (a[j] == b[j])
        for k = j+1:n-1
            a[k] = 0
            b[k] = m
        end
        a[end] = 0
    end

    return (part, (a,b,n,m))
end

let _nsetpartitions = Dict{Int,Int}()
    global nsetpartitions
    function nsetpartitions(n::Int)
        if n < 0
            0
        elseif n < 2
            1
        elseif (wn = get(_nsetpartitions, n, 0)) > 0
            wn
        else
            wn = 0
            for k = 0:n-1
                wn += binomial(n-1,k)*nsetpartitions(n-1-k)
            end
            _nsetpartitions[n] = wn
        end
    end
end

struct FixedSetPartitions{T<:AbstractVector}
    s::T
    m::Int
end

Base.length(p::FixedSetPartitions) = nfixedsetpartitions(length(p.s),p.m)
Base.eltype(p::FixedSetPartitions) = Vector{Vector{eltype(p.s)}}

"""
    partitions(s::AbstractVector, m::Int)

Generate all set partitions of the elements of an array `s` into exactly `m` subsets,
represented as arrays of arrays. Because the number of partitions can be very large,
this function returns an iterator object. Use `collect(partitions(s, m))` to get
an array of all partitions. The number of partitions into `m` subsets is equal to the
Stirling number of the second kind, and can be efficiently computed using
`length(partitions(s, m))`.
"""
partitions(s::AbstractVector, m::Int) =
    length(s) >= 1 && m >= 1 ?
        FixedSetPartitions(s, m) :
        throw(DomainError((length(s), m), "length(s) and m must be positive"))

function Base.iterate(p::FixedSetPartitions)
    n = length(p.s)
    m = p.m
    state = m <= n ? (vcat(ones(Int, n-m),1:m), vcat(1:1,n-m+2:n), n) : (Int[], Int[], n)
    # state consists of:
    # vector a of length n describing to which partition every element of s belongs
    # vector b of length n describing the first index b[i] that belongs to partition i
    # integer n

    iterate(p, state)
end

function Base.iterate(p::FixedSetPartitions, s)
    (isempty(s[1]) || s[1][1] > 1) && return
    nextfixedsetpartition(p.s,p.m, s...)
end

function nextfixedsetpartition(s::AbstractVector, m, a, b, n)
    function makeparts(s, a)
        local part = [ similar(s,0) for k = 1:m ]
        for i = 1:n
            push!(part[a[i]], s[i])
        end
        return part
    end

    part = makeparts(s,a)

    if m == 1
        a[1] = 2
        return (part, (a, b, n))
    end

    if a[end] != m
        a[end] += 1
    else
        j = k = 0
        for jj = n-1:-1:1
            j = jj
            if a[j] < m && b[a[j]+1] < j
                break
            end
        end
        if j > 1
            a[j] += 1
            for p = j+1:n
                if b[a[p]] != p
                    a[p] = 1
                end
            end
        else
            for kk = m:-1:2
                k = kk
                if b[k-1] < b[k] - 1
                    break
                end
            end
            b[k] -= 1
            b[k+1:m] = n-m+k+1:n
            a[1:n] .= 1
            a[b] = 1:m
        end
    end

    return (part, (a,b,n))
end

function nfixedsetpartitions(n::Int, m::Int)
    numpart = 0
    for k = 0:m
        numpart += (-1)^(m-k) * binomial(m, k) * (k^n)
    end
    numpart = div(numpart, factorial(m))
    return numpart
end

# TODO: Base.DSP is no longer a thing in Julia 0.7
#This function is still defined in Base because it is being used by Base.DSP
#"""
#Next integer not less than `n` that can be written as $\prod k_i^{p_i}$ for integers $p_1$, $p_2$, etc.
#
#For a list of integers i1, i2, i3, find the smallest
#    i1^n1 * i2^n2 * i3^n3 >= x
#for integer n1, n2, n3
#"""
#function nextprod(a::Vector{Int}, x)
#    if x > typemax(Int)
#        throw(ArgumentError("unsafe for x > typemax(Int), got $x"))
#    end
#    k = length(a)
#    v = ones(Int, k)                  # current value of each counter
#    mx = [nextpow(ai,x) for ai in a]  # maximum value of each counter
#    v[1] = mx[1]                      # start at first case that is >= x
#    p::widen(Int) = mx[1]             # initial value of product in this case
#    best = p
#    icarry = 1
#
#    while v[end] < mx[end]
#        if p >= x
#            best = p < best ? p : best  # keep the best found yet
#            carrytest = true
#            while carrytest
#                p = div(p, v[icarry])
#                v[icarry] = 1
#                icarry += 1
#                p *= a[icarry]
#                v[icarry] *= a[icarry]
#                carrytest = v[icarry] > mx[icarry] && icarry < k
#            end
#            if p < x
#                icarry = 1
#            end
#        else
#            while p < x
#                p *= a[1]
#                v[1] *= a[1]
#            end
#        end
#    end
#    best = mx[end] < best ? mx[end] : best
#    return Int(best)  # could overflow, but best to have predictable return type
#end

"""
    prevprod(a::Vector{Int}, x)

Previous integer not greater than `x` that can be written as ``\\prod k_i^{p_i}`` for
integers ``p_1``, ``p_2``, etc.

For integers ``i_1``, ``i_2``, ``i_3``, this is equivalent to finding the largest ``x``
such that

``i_1^{n_1} i_2^{n_2} i_3^{n_3} \\leq x``

for integers ``n_1``, ``n_2``, ``n_3``.
"""
function prevprod(a::Vector{Int}, x)
    if x > typemax(Int)
        throw(ArgumentError("unsafe for x > typemax(Int), got $x"))
    end
    k = length(a)
    v = ones(Int, k)                  # current value of each counter
    mx = [nextpow(ai,x) for ai in a]  # allow each counter to exceed p (sentinel)
    first = Int(prevpow(a[1], x))     # start at best case in first factor
    v[1] = first
    p::widen(Int) = first
    best = p
    icarry = 1

    while v[end] < mx[end]
        while p <= x
            best = p > best ? p : best
            p *= a[1]
            v[1] *= a[1]
        end
        if p > x
            carrytest = true
            while carrytest
                p = div(p, v[icarry])
                v[icarry] = 1
                icarry += 1
                p *= a[icarry]
                v[icarry] *= a[icarry]
                carrytest = v[icarry] > mx[icarry] && icarry < k
            end
            if p <= x
                icarry = 1
            end
        end
    end
    best = x >= p > best ? p : best
    return Int(best)
end


"""
    integer_partitions(n)

List the partitions of the integer `n`.

!!! note
    The order of the resulting array is consistent with that produced by the computational
    discrete algebra software GAP.
"""
function integer_partitions(n::Integer)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    elseif n == 0
        return Vector{Int}[]
    elseif n == 1
        return Vector{Int}[[1]]
    end

    list = Vector{Int}[]

    for p in integer_partitions(n-1)
        push!(list, [p; 1])
        if length(p) == 1 || p[end] < p[end-1]
            push!(list, [p[1:end-1]; p[end]+1])
        end
    end

    list
end



#Noncrossing partitions

const _cmp = cmp

#Produces noncrossing partitions of length n
function ncpartitions(n::Int)
    partitions = Vector{Vector{Int}}[]
    _ncpart!(1,n,n,Vector{Int}[], partitions)
    partitions
end

function _ncpart!(a::Int, b::Int, nn::Int, x::Vector, partitions::Vector)
    n = b - a + 1
    for k = 1:n, root in CoolLexCombinations(n, k)
        root .+= a - 1
        #Abort if construction is out of lex order
        !isempty(x) && _cmp(x[end], root) == 1 && return

        #Save if we've filled all the holes
        sofar = Vector{Int}[x..., root]
        ssofaru = sort!(union(sofar...))
        if length(ssofaru) == nn && ssofaru == collect(1:nn)
            push!(partitions, sofar)
            return
        end

        #otherwise patch all remaining holes
        blob = [ssofaru; nn + 1]
        for l = 1:length(blob)-1
            ap, bp = blob[l] + 1, blob[l+1] - 1
            ap <= bp && _ncpart!(ap, bp, nn, sofar, partitions)
        end
    end
end

################################################################################
# Young diagrams, partitions of unity and characters of the symmetric group Sn #
################################################################################

struct Partition
    x::Vector{Int}
end
Base.length(p::Partition) = length(p.x)
Base.getindex(p::Partition, i::Integer) = getindex(p.x, i)

struct SkewDiagram
    λ::Partition
    μ::Partition

    function SkewDiagram(λ::Partition, μ::Partition)
        m, n = length(λ), length(μ)
        n > m && throw(ArgumentError("Cannot construct skew diagram with partition lengths $m, $n"))
        new(λ, μ)
    end
end
SkewDiagram(λ::Vector{Int}, μ::Vector{Int}) = SkewDiagram(Partition(λ), Partition(μ))
SkewDiagram(t::Union{NTuple{2,Partition},NTuple{2,Vector{Int}}}) = SkewDiagram(t...)

export Partition,
       SkewDiagram,  #skew diagrams
       partitionsequence,
       isrimhook,    #Check if skew diagram is rim hook
       leglength,
       character     #Computes character of irrep of Sn

#################
# Skew diagrams #
#################

# This uses a very simple internal representation for skew diagrams
Base.:\(λ::Partition, μ::Partition) = SkewDiagram(λ, μ)

"""
    isrimhook(ξ::SkewDiagram)
    isrimhook(λ::Partition, μ::Partition)

Check whether the given skew diagram is a rim hook.
"""
isrimhook(λ::Partition, μ::Partition) = isrimhook(λ \ μ)
function isrimhook(ξ::SkewDiagram)
    λ = ξ.λ
    μ = ξ.μ
    m, n = length(λ), length(μ)
    n > m && error("Cannot construct skew diagram")
    #Construct matrix representation of diagram
    #XXX This is a horribly inefficient way of checking condition 1!
    l = maximum(λ.x)
    youngdiagram = zeros(Int, m, l)
    for i = 1:n
        youngdiagram[i, μ[i]+1:λ[i]] .= 1
    end
    for i = n+1:m
        youngdiagram[i, 1:λ[i]] .= 1
    end
    #Condition 1. Must be edgewise connected
    youngdiagramList = Any[]
    for i = 1:m
        for j = 1:l
            if youngdiagram[i, j] == 1
                push!(youngdiagramList, (i, j))
            end
        end
    end
    for k = 1:length(youngdiagramList)
        i, j = youngdiagramList[k]
        numNeighbors = 0
        for kp = 1:length(youngdiagramList)
            ip, jp = youngdiagramList[kp]
            if abs(i-ip) + abs(j-jp) == 1
                numNeighbors += 1
            end
        end
        if numNeighbors == 0 #Found a cell with no adjacent neighbors
            return false
        end
    end
    #Condition 2. Must not contain 2x2 square of cells
    for i = 1:m-1
        for j = 1:l-1
            if youngdiagram[i, j] == 0
                continue
            end
            if youngdiagram[i, j+1] == youngdiagram[i+1, j] == youngdiagram[i+1, j+1] == 1
                return false
            end
        end
    end
    return true
end


"""
    leglength(ξ::SkewDiagram)
    leglength(λ::Partition, μ::Partition)

Compute the leg length for the given skew diagram.

!!! note
    Strictly speaking, the leg length is defined for rim hooks only, but here we define
    it for all skew diagrams.
"""
leglength(λ::Partition, μ::Partition) = leglength(λ \ μ)
function leglength(ξ::SkewDiagram)
    λ = ξ.λ
    μ = ξ.μ
    m, n = length(λ), length(μ)
    #Construct matrix representation of diagram
    m == 0 && return -1
    l = maximum(λ.x)
    youngdiagram = zeros(Int, m, l)
    for i = 1:n
        youngdiagram[i, μ[i]+1:λ[i]] .= 1
    end
    for i = n+1:m
        youngdiagram[i, 1:λ[i]] .= 1
    end
    for i = m:-1:1
        any(==(1), youngdiagram[i,:]) && return i-1
    end
    return -1 #If entire matrix is empty
end


#######################
# partition sequences #
#######################

"""
    partitionsequence(lambda::Partition)

Compute essential part of the partition sequence of `lambda`.
"""
function partitionsequence(lambda::Partition)
    Λ▔ = Int[]
    λ = [lambda.x; 0]
    m = length(lambda)
    for i = m:-1:1
        for k = 1:(λ[i]-λ[i+1])
            push!(Λ▔, 1)
        end
        push!(Λ▔, 0)
    end
    Λ▔
end

"""
    isrimhook(a::Int, b::Int)

Take two elements of a partition sequence, with `a` to the left of `b`.
"""
isrimhook(a::Int, b::Int) = (a == 1) && (b == 0)


#############################
# Character of irreps of Sn #
#############################

"""
Recursively compute the character of the partition `μ` using the Murnaghan-Nakayama rule.
"""
function MN1inner(R::Vector{Int}, T::Dict, μ::Partition, t::Integer)
    s = length(R)
    χ::Integer = 1
    if t <= length(μ)
        χ, σ::Integer = 0, 1
        for j = 1:μ[t]-1
            if R[j] == 0
                σ = -σ
            end
        end
        for i = 1:s-μ[t]
            if R[i] != R[i+μ[t]-1]
                σ = -σ
            end
            if isrimhook(R[i], R[i+μ[t]])
                R[i], R[i+μ[t]] = R[i+μ[t]], R[i]
                rhohat = R[i:i+μ[t]]
                if !haskey(T, rhohat) #Cache result in lookup table
                    T[rhohat] = MN1inner(R, T, μ, t+1)
                end
                χ += σ * T[rhohat]
                R[i], R[i+μ[t]] = R[i+μ[t]], R[i]
            end
        end
    end
    χ
end

"""
    character(λ::Partition, μ::Partition)

Compute the character ``\\chi^{\\lambda(\\mu)}`` of the partition `μ` in the `λ`th
irreducible representation ("irrep") of the symmetric group ``S_n``.

Implements the Murnaghan-Nakayama algorithm as described in:

    Dan Bernstein,
    "The computational complexity of rules for the character table of Sn",
    Journal of Symbolic Computation, vol. 37 iss. 6 (2004), pp 727-748.
    doi:10.1016/j.jsc.2003.11.001
"""
character(λ::Partition, μ::Partition) =
    MN1inner(partitionsequence(λ), Dict{Any,Int}(()=>0), μ, 1)

## Deprecations
# Previously these were defined in terms of Base types. It's not possible to deprecate
# the use of `\` for the old-style `Partition`s though, since it's hardcore type piracy
# to overwrite `Base.:\(::Vector, ::Vector)` to begin with, let alone overwrite it with
# a deprecation.

using Base: @deprecate, @deprecate_binding

@deprecate isrimhook(λ::Vector{Int}, μ::Vector{Int}) isrimhook(Partition(λ), Partition(μ))
@deprecate isrimhook(ξ::NTuple{2,Vector{Int}})       isrimhook(SkewDiagram(ξ))
@deprecate leglength(λ::Vector{Int}, μ::Vector{Int}) leglength(Partition(λ), Partition(μ))
@deprecate leglength(ξ::NTuple{2,Vector{Int}})       leglength(SkewDiagram(ξ))
@deprecate character(λ::Vector{Int}, μ::Vector{Int}) character(Partition(λ), Partition(μ))
@deprecate partitionsequence(λ::Vector{Int})         partitionsequence(Partition(λ))

# This isn't actually used anywhere and is not a particularly useful alias
# TODO: Perhaps revisit YoungDiagram as its own type should the need arise
@deprecate_binding YoungDiagram Matrix{Int}

@testset "partitions" begin

    @testset "partitions(n::Integer)" begin
        @test_broken collect(partitions(0)) == [[]]
        @test collect(partitions(1)) == [[1]]
        @test collect(partitions(2)) == [[2], [1, 1]]
        @test collect(partitions(3)) == [[3], [2, 1], [1, 1, 1]]
        @test collect(partitions(4)) == [[4], [3, 1], [2, 2], [2, 1, 1], [1, 1, 1, 1]]

        # Partition function p(n):  https://oeis.org/A000041
        @test length(partitions(-1)) == 0
        @test length(partitions(0)) == 1
        @test length(partitions(1)) == 1
        @test length(partitions(40)) == 37338
        @test length(partitions(49)) == 173525
        @test length(collect(partitions(30))) == length(partitions(30))

        # Type stable
        @inferred first(partitions(4))
        @test isa(collect(partitions(4)), Vector{Vector{Int}})
    end

    @testset "partitions(n::Integer, m::Integer)" begin
        @test collect(partitions(8, 1)) == [[8]]
        @test collect(partitions(8, 3)) == [[6, 1, 1], [5, 2, 1], [4, 3, 1], [4, 2, 2], [3, 3, 2]]
        @test collect(partitions(8, 8)) == [ones(Int, 8)]
        @test collect(partitions(8, 9)) == []
        @test collect(partitions(90, 90)) == [ones(Int, 90)]
        @test collect(partitions(90, 91)) == []

        # legnth
        @test length(partitions(8, 1)) == 1
        @test length(partitions(8, 3)) == 5
        @test length(partitions(8, 8)) == 1
        @test length(partitions(8, 9)) == 0
        @test length(partitions(90, 1)) == 1
        # gap> NrPartitions(90, 4);
        @test length(partitions(90, 4)) == 5231
        @test length(collect(partitions(90, 4))) == length(partitions(90, 4))
        @test length(partitions(90, 90)) == 1

        # Type stable
        @inferred first(partitions(8, 3))
        @test isa(collect(partitions(8, 3)), Vector{Vector{Int}})

        # errors
        @test_throws DomainError partitions(-1, 1)
        @test_throws DomainError partitions(8, 0)
        @test_throws DomainError partitions(8, -1)
    end

    @testset "partitions(s::AbstractVector)" begin
        @test collect(partitions([1])) == [[[1]]]
        @test collect(partitions([1, 2])) == [[[1, 2]], [[1], [2]]]
        @test collect(partitions([1, 2, 3])) == [[[1, 2, 3]], [[1, 2], [3]], [[1, 3], [2]], [[1], [2, 3]], [[1], [2], [3]]]
        @test collect(partitions(1:3)) == collect(partitions([1, 2, 3]))
        @test collect(partitions('a':'b')) == [[['a', 'b']], [['a'], ['b']]]

        # length:  https://oeis.org/A000110
        @test length(partitions(1:10)) == 115975
        @test length(partitions(1:20)) == 51724158235372
        @test length(collect(partitions('a':'h'))) == length(partitions('a':'h'))

        # Type stable
        @inferred first(partitions([1, 2, 3]))
        @test isa(collect(partitions([1, 2, 3])), Vector{Vector{Vector{Int}}})
    end

    @testset "partitions(s::AbstractVector, m::Int)" begin
        @test collect(partitions(1:3, 2)) == [
            [[1, 2], [3]],
            [[1, 3], [2]],
            [[1], [2, 3]],
        ]
        @test collect(partitions([1, 2, 3, 4], 1)) == [[[1, 2, 3, 4]]]
        @test collect(partitions([1, 2, 3, 4], 3)) == [
            [[1, 2], [3], [4]], [[1, 3], [2], [4]], [[1], [2, 3], [4]],
            [[1, 4], [2], [3]], [[1], [2, 4], [3]], [[1], [2], [3, 4]]
        ]
        @test collect(partitions([1, 2, 3, 4], 4)) == [[[1], [2], [3], [4]]]
        @test collect(partitions([1, 2, 3, 4], 5)) == []

        # length: Stirling numbers of the second kind
        #   https://dlmf.nist.gov/26.8#T2
        @test length(partitions(1:3, 2)) == 3
        @test length(partitions([1, 2, 3, 4], 3)) == 6
        @test length(partitions(1:10, 4)) == 34105
        @test length(partitions(1:10, 5)) == 42525
        @test length(partitions(1:10, 5)) == stirlings2(10, 5)
        @test length(partitions(1:10, 6)) == 22827
        @test length(collect(partitions('a':'h', 5))) == length(partitions('a':'h', 5))

        # Type stable
        @inferred first(partitions([1, 2, 3, 4], 3))
        @test isa(collect(partitions([1, 2, 3, 4], 3)), Vector{Vector{Vector{Int}}})
    end

    @testset "integer partitions" begin
        @test integer_partitions(0) == [Int[]]
        @test integer_partitions(1) == [[1]]
        @test integer_partitions(2) == [[1, 1], [2]]
        @test integer_partitions(3) == [[1, 1, 1], [2, 1], [3]]
        # gap> Partitions( 5 );
        @test integer_partitions(5) == [
            [1, 1, 1, 1, 1],
            [2, 1, 1, 1],
            [2, 2, 1],
            [3, 1, 1],
            [3, 2],
            [4, 1],
            [5]
        ]
        # integer_partitions <--> partitions(::Integer)
        @test Set(integer_partitions(5)) == Set(partitions(5))

        # Partition function p(n):  https://oeis.org/A000041
        @test length(integer_partitions(0)) == 1
        @test length(integer_partitions(1)) == 1
        @test length(integer_partitions(2)) == 2
        @test length(integer_partitions(3)) == 3
        @test length(integer_partitions(4)) == 5
        @test length(integer_partitions(5)) == 7
        @test length(integer_partitions(40)) == 37338
        @test length(integer_partitions(49)) == 173525

        @test_throws DomainError integer_partitions(-1)
    end

    @testset "prevprod" begin
        @test prevprod([2, 3, 5], 30) == 30         # 30 = 2 * 3 * 5
        @test prevprod([2, 3, 5], 33) == 32         # 32 = 2^5
        @test prevprod([2, 3, 5, 7], 420) == 420    # 420 = 2^2 * 3 * 5 * 7

        # prime factor:  https://en.wikipedia.org/wiki/Table_of_prime_factors
        prime_factors = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37]
        @test prevprod(prime_factors, 37) == 37
        @test prevprod(prime_factors, 97) == 96     # 96 = 2^5 * 3
        @test prevprod(prime_factors, 149) == 148   # 148 = 2^2 * 37
        @test prevprod(prime_factors, 911) == 910   # 910 = 2 * 5 * 7 * 13
        @test prevprod(prime_factors, 4999) == 4998 # 4998 = 2 * 3 * 7^2 * 17

        # errors
        @test_throws ArgumentError prevprod([2, 3, 5], Int128(typemax(Int)) + 1)
    end

    @testset "noncrossing partitions" begin
        @test ncpartitions(0) == []
        @test ncpartitions(1) == [[[1]]]
        @test ncpartitions(2) == [[[1], [2]], [[1, 2]]]
        # The 14 noncrossing partitions of a 4-element set ordered in a Hasse diagram
        #   https://commons.wikimedia.org/wiki/File:Noncrossing_partitions_4;_Hasse.svg
        @test ncpartitions(4) == [
            [[1], [2], [3], [4]],
            [[1], [2], [3, 4]],
            [[1], [2, 3], [4]],
            [[1], [2, 4], [3]],
            [[1], [2, 3, 4]],
            [[1, 2], [3], [4]],
            [[1, 2], [3, 4]],
            [[1, 3], [2], [4]],
            [[1, 4], [2], [3]],
            [[1, 4], [2, 3]],
            [[1, 2, 3], [4]],
            [[1, 3, 4], [2]],
            [[1, 2, 4], [3]],
            [[1, 2, 3, 4]],
        ]

        for n in 1:8
            @test length(ncpartitions(n)) == catalannum(n)
        end
    end

end

#Permutations

export
    derangements,
    levicivita,
    multiset_permutations,
    nthperm!,
    nthperm,
    parity,
    permutations


struct Permutations{T}
    data::T
    length::Int
end

# The following code basically implements `permutations` in terms of `multiset_permutations` as
#
#     permutations(a, t::Integer=length(a)) = Iterators.map(
#         indices -> [a[i] for i in indices],
#         multiset_permutations(eachindex(a), t))
#
# with the difference that we can also define `eltype(::Permutations)`, which is used in some tests.

function Base.iterate(p::Permutations, state=nothing)
    if state === nothing
        mp = multiset_permutations(collect(eachindex(p.data)), p.length)
        it = iterate(mp)
        if it === nothing return nothing end
    else
        mp, mp_state = state
        it = iterate(mp, mp_state)
        if it === nothing return nothing end
    end
    indices, mp_state = it
    return [p.data[i] for i in indices], (mp=mp, mp_state=mp_state)
end

function Base.length(p::Permutations)
    length(p.data) < p.length && return 0
    return Int(prod(length(p.data) - p.length + 1:length(p.data)))
end

Base.eltype(p::Permutations) = Vector{eltype(p.data)}

Base.IteratorSize(p::Permutations) = Base.HasLength()


"""
    permutations(a)

Generate all permutations of an indexable object `a` in lexicographic order. Because the number of permutations
can be very large, this function returns an iterator object.
Use `collect(permutations(a))` to get an array of all permutations.
Only works for `a` with defined length.

# Examples
```jldoctest
julia> permutations(1:2)
Combinatorics.Permutations{UnitRange{Int64}}(1:2, 2)

julia> collect(permutations(1:2))
2-element Vector{Vector{Int64}}:
 [1, 2]
 [2, 1]

julia> collect(permutations(1:3))
6-element Vector{Vector{Int64}}:
 [1, 2, 3]
 [1, 3, 2]
 [2, 1, 3]
 [2, 3, 1]
 [3, 1, 2]
 [3, 2, 1]
```
"""
permutations(a) = permutations(a, length(a))

"""
    permutations(a, t)

Generate all size `t` permutations of an indexable object `a`.
Only works for `a` with defined length.
If `(t <= 0) || (t > length(a))`, then returns an empty vector of eltype of `a`

# Examples
```jldoctest
julia> [ (len, permutations(1:3, len)) for len in -1:4 ]
6-element Vector{Tuple{Int64, Any}}:
 (-1, Vector{Int64}[])
 (0, [Int64[]])
 (1, [[1], [2], [3]])
 (2, Combinatorics.Permutations{UnitRange{Int64}}(1:3, 2))
 (3, Combinatorics.Permutations{UnitRange{Int64}}(1:3, 3))
 (4, Vector{Int64}[])

julia> [ (len, collect(permutations(1:3, len))) for len in -1:4 ]
6-element Vector{Tuple{Int64, Vector{Vector{Int64}}}}:
 (-1, [])
 (0, [[]])
 (1, [[1], [2], [3]])
 (2, [[1, 2], [1, 3], [2, 1], [2, 3], [3, 1], [3, 2]])
 (3, [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]])
 (4, [])
```
"""
function permutations(a, t::Integer)
    if t == 0
        # Correct behavior for a permutation of length 0 is a vector containing a single empty vector
        return [Vector{eltype(a)}()]
    elseif t == 1
        # Easy case, just return each element in its own vector
        return [[ai] for ai in a]
    elseif t < 0 || t > length(a)
        # Correct behavior for a permutation of these lengths is a an empty vector (of the correct type)
        return Vector{Vector{eltype(a)}}()
    end
    return Permutations(a, t)
end

"""
    derangements(a)

Generate all derangements of an indexable object `a` in lexicographic order.
Because the number of derangements can be very large, this function returns an iterator object.
Use `collect(derangements(a))` to get an array of all derangements.
Only works for `a` with defined length.

# Examples
```jldoctest
julia> derangements("julia") |> collect
44-element Vector{Vector{Char}}:
 ['u', 'j', 'i', 'a', 'l']
 ['u', 'j', 'a', 'l', 'i']
 ['u', 'l', 'j', 'a', 'i']
 ['u', 'l', 'i', 'a', 'j']
 ['u', 'l', 'a', 'j', 'i']
 ['u', 'i', 'j', 'a', 'l']
 ['u', 'i', 'a', 'j', 'l']
 ['u', 'i', 'a', 'l', 'j']
 ['u', 'a', 'j', 'l', 'i']
 ['u', 'a', 'i', 'j', 'l']
 ⋮
 ['a', 'j', 'i', 'l', 'u']
 ['a', 'l', 'j', 'u', 'i']
 ['a', 'l', 'u', 'j', 'i']
 ['a', 'l', 'i', 'j', 'u']
 ['a', 'l', 'i', 'u', 'j']
 ['a', 'i', 'j', 'u', 'l']
 ['a', 'i', 'j', 'l', 'u']
 ['a', 'i', 'u', 'j', 'l']
 ['a', 'i', 'u', 'l', 'j']
```
"""
derangements(a) = (d for d in multiset_permutations(a, length(a)) if all(t -> t[1] != t[2], zip(a, d)))


function nextpermutation(m, t, state)
    perm = [m[state[i]] for i in 1:t]
    n = length(state)
    if t <= 0
        return (perm, [n + 1])
    end
    s = copy(state)
    if t < n
        j = t + 1
        while j <= n && s[t] >= s[j]
            j += 1
        end
    end
    if t < n && j <= n
        s[t], s[j] = s[j], s[t]
    else
        if t < n
            reverse!(s, t + 1)
        end
        i = t - 1
        while i >= 1 && s[i] >= s[i+1]
            i -= 1
        end
        if i > 0
            j = n
            while j > i && s[i] >= s[j]
                j -= 1
            end
            s[i], s[j] = s[j], s[i]
            reverse!(s, i + 1)
        else
            s[1] = n + 1
        end
    end
    return (perm, s)
end

struct MultiSetPermutations{T}
    m::T
    f::Vector{Int}
    t::Int
    ref::Vector{Int}
end

Base.eltype(::Type{MultiSetPermutations{T}}) where {T} = Vector{eltype(T)}

function Base.length(c::MultiSetPermutations)
    t = c.t
    if t > length(c.ref)
        return 0
    end
    if t > 20
        g = [factorial(big(i)) for i in 0:t]
    else
        g = [factorial(i) for i in 0:t]
    end
    p = [g[t+1]; zeros(Float64, t)]
    for i in 1:length(c.f)
        f = c.f[i]
        if i == 1
            for j in 1:min(f, t)
                p[j+1] = g[t+1] / g[j+1]
            end
        else
            for j in t:-1:1
                q = 0
                for k in (j+1):-1:max(1, j + 1 - f)
                    q += p[k] / g[j+2-k]
                end
                p[j+1] = q
            end
        end
    end
    return round(Int, p[t+1])
end


"""
    multiset_permutations(a)

Generate all permutations of an array `a` where `a` may have duplicated elements.
"""
multiset_permutations(a) = multiset_permutations(a, length(a))

"""
    multiset_permutations(a, t)

Generate all permutations of size `t` from an array `a` where `a` may have duplicated elements.

# Examples
```jldoctest
julia> collect(permutations([1,1,1], 2))
6-element Vector{Vector{Int64}}:
 [1, 1]
 [1, 1]
 [1, 1]
 [1, 1]
 [1, 1]
 [1, 1]

julia> collect(multiset_permutations([1,1,1], 2))
1-element Vector{Vector{Int64}}:
 [1, 1]

julia> collect(multiset_permutations([1,1,2], 3))
3-element Vector{Vector{Int64}}:
 [1, 1, 2]
 [1, 2, 1]
 [2, 1, 1]
```
"""
function multiset_permutations(a, t::Integer)
    m = unique(a)
    f = [sum(c == x for c in a)::Int for x in m]
    multiset_permutations(m, f, t)
end

function multiset_permutations(m, f::Vector{<:Integer}, t::Integer)
    length(m) == length(f) || error("Lengths of m and f are not the same.")
    ref = length(f) > 0 ? vcat([[i for j in 1:f[i]] for i in 1:length(f)]...) : Int[]
    if t < 0
        t = length(ref) + 1
    end
    MultiSetPermutations(m, f, t, ref)
end

function Base.iterate(p::MultiSetPermutations, s=p.ref)
    (!isempty(s) && max(s[1], p.t) > length(p.ref) || (isempty(s) && p.t > 0)) && return
    nextpermutation(p.m, p.t, s)
end


"""
    nthperm!(a, k)

In-place version of [`nthperm`](@ref); the array `a` is overwritten.

# Examples
```jldoctest
julia> a = [1, 2, 3];

julia> collect(permutations(a))
6-element Vector{Vector{Int64}}:
 [1, 2, 3]
 [1, 3, 2]
 [2, 1, 3]
 [2, 3, 1]
 [3, 1, 2]
 [3, 2, 1]

julia> nthperm!(a, 3); a
3-element Vector{Int64}:
 2
 1
 3

julia> nthperm!(a, 4); a
3-element Vector{Int64}:
 1
 3
 2

julia> nthperm!(a, 0)
ERROR: ArgumentError: permutation k must satisfy 0 < k ≤ 6, got 0
[...]
```
"""
function nthperm!(a::AbstractVector, k::Integer)
    n = length(a)
    n == 0 && return a
    f = factorial(oftype(k, n))
    0 < k <= f || throw(ArgumentError("permutation k must satisfy 0 < k ≤ $f, got $k"))
    k -= 1 # make k 1-indexed
    for i = 1:n-1
        f ÷= n - i + 1
        j = k ÷ f
        k -= j * f
        j += i
        elt = a[j]
        for d = j:-1:i+1
            a[d] = a[d-1]
        end
        a[i] = elt
    end
    a
end

"""
    nthperm(a, k)

Compute the `k`th lexicographic permutation of the vector `a`.

# Examples
```jldoctest
julia> collect(permutations([1,2]))
2-element Vector{Vector{Int64}}:
 [1, 2]
 [2, 1]

julia> nthperm([1,2], 1)
2-element Vector{Int64}:
 1
 2

julia> nthperm([1,2], 2)
2-element Vector{Int64}:
 2
 1

julia> nthperm([1,2], 3)
ERROR: ArgumentError: permutation k must satisfy 0 < k ≤ 2, got 3
[...]
```
"""
nthperm(a::AbstractVector, k::Integer) = nthperm!(collect(a), k)

"""
    nthperm(p)

Return the integer `k` that generated permutation `p`. Note that
`nthperm(nthperm([1:n], k)) == k` for `1 <= k <= factorial(n)`.

# Examples
```jldoctest
julia> nthperm(nthperm([1:3...], 4))
4

julia> collect(permutations([1, 2, 3]))
6-element Vector{Vector{Int64}}:
 [1, 2, 3]
 [1, 3, 2]
 [2, 1, 3]
 [2, 3, 1]
 [3, 1, 2]
 [3, 2, 1]

julia> nthperm([1, 2, 3])
1

julia> nthperm([3, 2, 1])
6

julia> nthperm([1, 1, 1])
ERROR: ArgumentError: argument is not a permutation
[...]

julia> nthperm(collect(1:10))
1

julia> nthperm(collect(10:-1:1))
3628800
```
"""
function nthperm(p::AbstractVector{<:Integer})
    isperm(p) || throw(ArgumentError("argument is not a permutation"))
    k, n = 1, length(p)
    for i = 1:n-1
        f = factorial(n - i)
        for j = i+1:n
            k += ifelse(p[j] < p[i], f, 0)
        end
    end
    return k
end


# Parity of permutations

const levicivita_lut = cat([0 0 0; 0 0 1; 0 -1 0],
                           [0 0 -1; 0 0 0; 1 0 0],
                           [0 1 0; -1 0 0; 0 0 0];
                           dims=3)

"""
    levicivita(p)

Compute the Levi-Civita symbol of a permutation `p`. Returns 1 if the permutation
is even, -1 if it is odd, and 0 otherwise.

The parity is computed by using the fact that a permutation is odd if and
only if the number of even-length cycles is odd.

# Examples
```jldoctest
julia> levicivita([1, 2, 3])
1

julia> levicivita([3, 2, 1])
-1

julia> levicivita([1, 1, 1])
0

julia> levicivita(collect(1:100))
1

julia> levicivita(ones(Int, 100))
0
```
"""
function levicivita(p::AbstractVector{<:Integer})
    n = length(p)

    if n == 3
        @inbounds valid = (0 < p[1] <= 3) * (0 < p[2] <= 3) * (0 < p[3] <= 3)
        return valid ? levicivita_lut[p[1], p[2], p[3]] : 0
    end

    todo = trues(n)
    first = 1
    cycles = flips = 0

    while cycles + flips < n
        first = coalesce(findnext(todo, first), 0)
        (todo[first] = !todo[first]) && return 0
        j = p[first]
        (0 < j <= n) || return 0
        cycles += 1
        while j ≠ first
            (todo[j] = !todo[j]) && return 0
            j = p[j]
            (0 < j <= n) || return 0
            flips += 1
        end
    end

    return iseven(flips) ? 1 : -1
end

"""
    parity(p)

Compute the parity of a permutation `p` using the [`levicivita`](@ref) function,
permitting calls such as `iseven(parity(p))`. If `p` is not a permutation then an
error is thrown.

# Examples
```jldoctest
julia> parity([1, 2, 3])
0

julia> parity([3, 2, 1])
1

julia> parity([1, 1, 1])
ERROR: ArgumentError: Not a permutation
[...]

julia> parity((collect(1:100)))
0
```
"""
function parity(p::AbstractVector{<:Integer})
    epsilon = levicivita(p)
    epsilon == 0 && throw(ArgumentError("Not a permutation"))
    epsilon == 1 ? 0 : 1
end

@testset "combinations" begin
    @test [combinations([])...] == [[]]
    @test [combinations(['a', 'b', 'c'])...] == [[],['a'],['b'],['c'],['a','b'],['a','c'],['b','c'],['a','b','c']]
    @test length(collect(combinations(1:5))) == 32

    @test [combinations("abc", 3)...] == [['a', 'b', 'c']]
    @test [combinations("abc", 2)...] == [['a', 'b'], ['a', 'c'], ['b', 'c']]
    @test [combinations("abc", 1)...] == [['a'], ['b'], ['c']]
    @test [combinations("abc", 0)...] == [[]]
    @test [combinations("abc", -1)...] == []

    @test filter(x -> iseven(x[1]), [combinations([1, 2, 3], 2)...]) == Any[[2, 3]]

    # multiset_combinations
    @test [multiset_combinations("aabc", 5)...] == Any[]
    @test [multiset_combinations("aabc", 2)...] == Any[['a', 'a'], ['a', 'b'], ['a', 'c'], ['b', 'c']]
    @test [multiset_combinations("aabc", 1)...] == Any[['a'], ['b'], ['c']]
    @test [multiset_combinations("aabc", 0)...] == Any[Char[]]
    @test [multiset_combinations("aabc", -1)...] == Any[]
    @test [multiset_combinations("", 1)...] == Any[]
    @test [multiset_combinations("", 0)...] == Any[Char[]]
    @test [multiset_combinations("", -1)...] == Any[]

    # with_replacement_combinations
    @test [with_replacement_combinations("abc", 2)...] == Any[['a', 'a'], ['a', 'b'], ['a', 'c'],
        ['b', 'b'], ['b', 'c'], ['c', 'c']]
    @test [with_replacement_combinations("abc", 1)...] == Any[['a'], ['b'], ['c']]
    @test [with_replacement_combinations("abc", 0)...] == Any[Char[]]
    @test [with_replacement_combinations("abc", -1)...] == Any[]
    @test [with_replacement_combinations("", 1)...] == Any[]
    @test [with_replacement_combinations("", 0)...] == Any[Char[]]
    @test [with_replacement_combinations("", -1)...] == Any[]


    #cool-lex iterator
    @test_throws DomainError [CoolLexCombinations(-1, 1)...]
    @test_throws DomainError [CoolLexCombinations(5, 0)...]
    @test [CoolLexCombinations(4, 2)...] == Vector[[1, 2], [2, 3], [1, 3], [2, 4], [3, 4], [1, 4]]
    @test isa(iterate(CoolLexCombinations(1000, 20))[2], Combinatorics.CoolLexIterState{BigInt})

    # Power set
    @test collect(powerset([])) == Any[[]]
    @test collect(powerset(['a', 'b', 'c'])) == Any[[], ['a'], ['b'], ['c'], ['a', 'b'], ['a', 'c'], ['b', 'c'], ['a', 'b', 'c']]
    @test collect(powerset(['a', 'b', 'c'], 1)) == Any[['a'], ['b'], ['c'], ['a', 'b'], ['a', 'c'], ['b', 'c'], ['a', 'b', 'c']]
    @test collect(powerset(['a', 'b', 'c'], 1, 2)) == Any[['a'], ['b'], ['c'], ['a', 'b'], ['a', 'c'], ['b', 'c']]

end

using Documenter
using Combinatorics

DocMeta.setdocmeta!(Combinatorics, :DocTestSetup, :(using Combinatorics); recursive=true)

makedocs(
    sitename="Combinatorics.jl",
    format = Documenter.HTML(
        prettyurls = get(ENV, "CI", nothing) == "true"
    ),
    pages = ["index.md", "api.md"]
)

deploydocs(;
    repo="github.com/JuliaMath/Combinatorics.jl.git",
    devbranch="master",
)

#Factorials and elementary coefficients

export
    derangement,
    partialderangement,
    factorial,
    subfactorial,
    doublefactorial,
    hyperfactorial,
    multifactorial,
    primorial,
    multinomial

# TODO: This should really live in Base, otherwise it's type piracy
"""
    factorial(n, k)

Compute ``n!/k!``.
"""
function Base.factorial(n::T, k::T) where T<:Integer
    if k < 0 || n < 0 || k > n
        throw(DomainError((n, k), "n and k must be nonnegative with k ≤ n"))
    end
    f = one(T)
    while n > k
        f = Base.checked_mul(f, n)
        n -= 1
    end
    return f
end
function Base.factorial(n::BigInt, k::BigInt)
    if k < 0 || n < 0 || k > n
        throw(DomainError((n, k), "n and k must be nonnegative with k ≤ n"))
    end
    f = BigInt(1)
    n = deepcopy(n)  # avoid mutating input
    while n > k
        Base.GMP.MPZ.mul!(f, n)
        Base.GMP.MPZ.sub_ui!(n, 1)
    end
    return f
end
Base.factorial(n::Integer, k::Integer) = factorial(promote(n, k)...)


"""
    derangement(n)

Compute the number of permutations of `n` with no fixed points, also known as the
subfactorial. An alias `subfactorial` for this function is provided for convenience.
"""
function derangement(n::Integer)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    elseif n <= 1
        return BigInt(1-n)
    end
    d = BigInt(0)
    for i in 2:n
        # d = i * d + (iseven(i) ? 1 : -1)
        Base.GMP.MPZ.mul_ui!(d, i)
        if iseven(i)
            Base.GMP.MPZ.add_ui!(d, 1)
        else
            Base.GMP.MPZ.sub_ui!(d, 1)
        end
    end
    return d
end
const subfactorial = derangement

function doublefactorial(n::Integer)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    end
    z = Ref{BigInt}(0)
    ccall((:__gmpz_2fac_ui, :libgmp), Cvoid, (Ref{BigInt}, UInt), z, UInt(n))
    return z[]
end

"""
    partialderangement(n, k)
    
Compute the number of permutations of `n` with exactly k fixed points.
"""
function partialderangement(n::Integer, k::Integer)
    if n < 0
        throw(DomainError(n))
    end
    if k < 0 || k > n
        throw(DomainError(k))
    end
    a = BigInt(n)
    b = BigInt(k)
    return subfactorial(a - b) * binomial(a, b)
end

# Hyperfactorial
hyperfactorial(n::Integer) = n==0 ? BigInt(1) : prod(i->i^i, BigInt(1):n)


function multifactorial(n::Integer, m::Integer)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    end
    z = Ref{BigInt}(0)
    ccall((:__gmpz_mfac_uiui, :libgmp), Cvoid, (Ref{BigInt}, UInt, UInt), z, UInt(n), UInt(m))
    return z[]
end

function primorial(n::Integer)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    end
    z = Ref{BigInt}(0)
    ccall((:__gmpz_primorial_ui, :libgmp), Cvoid, (Ref{BigInt}, UInt), z, UInt(n))
    return z[]
end

"""
    multinomial(k...)

Compute the multinomial coefficient
``\\binom{n}{k_1,k_2,...,k_i} = \\frac{n!}{k_1!k_2! \\cdots k_i!}, n = \\sum{k_i}``.
Throws an `OverflowError` when the input is too large.

See Also: `binomial`.

# Examples
```jldoctest
julia> # (x+y)^2 = x^2 + 2xy + y^2

julia> multinomial(2, 0)
1

julia> multinomial(1, 1)
2

julia> multinomial(0, 2)
1

julia> multinomial(10, 10, 10, 10)
ERROR: OverflowError: 5550996791340 * 847660528 overflowed for type Int64
Stacktrace:
[...]
```

# External links
- [Definitions](https://dlmf.nist.gov/26.4.2) on DLMF
- [Multinomial theorem](https://en.wikipedia.org/wiki/Multinomial_theorem) on Wikipedia
"""
function multinomial(k...)
    s = 0
    result = 1
    @inbounds for i in k
        s += i
        bi = binomial(s, i)
        result = Base.Checked.checked_mul(result, bi)
    end
    result
end

@testset "numbers" begin
      # catalan
      @test catalannum(5) == 42
      @test catalannum(30) == parse(BigInt, "3814986502092304")
      @test_throws DomainError catalannum(-1)

      # fibonacci
      @test fibonaccinum(5) == 5
      @test fibonaccinum(101) == parse(BigInt, "573147844013817084101")
      @test_throws DomainError fibonaccinum(-1)

      # lobb
      @test lobbnum(2, 3) == 5
      @test lobbnum(50, 100) == parse(BigInt, "303574146822833458064977353764024400258025594128")
      @test_throws DomainError lobbnum(-1, 2)

      # narayana
      @test narayana(8, 5) == 490
      @test narayana(100, 50) == parse(BigInt, "99794739256977899071474889425225225330079579752931446368")
      @test_throws DomainError narayana(-1, -1)

      # lassalle
      @test lassallenum(14) == parse(BigInt, "270316008395632253340")

      # legendresymbol
      @test legendresymbol(1001, 9907) == jacobisymbol(1001, 9907) == -1

      # lucas
      @test lucasnum(10) == 123
      @test lucasnum(100) == parse(BigInt, "792070839848372253127")
      @test_throws DomainError lucasnum(-1)

      # stirlings1
      @test_throws DomainError stirlings1(-1, 1)
      @test typeof(stirlings1(6, 2)) == Int
      @test stirlings1(0, 0) == 1
      @test stirlings1(1, 1) == 1
      @test stirlings1(2, 6) == 0
      @test stirlings1(6, 0) == 0
      @test stirlings1(6, 0, true) == 0
      @test stirlings1(6, 1) == 120
      @test stirlings1(6, 1, true) == -120
      @test stirlings1(6, 2) == 274
      @test stirlings1(6, 2, true) == 274
      @test stirlings1(6, 3) == 225
      @test stirlings1(6, 3, true) == -225
      @test stirlings1(6, 4) == 85
      @test stirlings1(6, 4, true) == 85
      @test stirlings1(6, 5) == 15
      @test stirlings1(6, 5, true) == -15
      @test stirlings1(6, 6) == 1
      @test stirlings1(6, 6, true) == 1
      @test sum([abs(stirlings1(8, i, true)) for i = 0:8]) == factorial(8)
      @test stirlings1(big"26", 10) == 196928100451110820242880

      # stirlings2
      @test_throws DomainError stirlings2(-1, 1)
      @test typeof(stirlings2(6, 2)) == Int
      @test stirlings2(0, 0) == 1
      @test stirlings2(1, 1) == 1
      @test stirlings2(2, 6) == 0
      @test stirlings2(6, 0) == 0
      @test stirlings2(6, 1) == 1
      @test stirlings2(6, 2) == 31
      @test stirlings2(6, 3) == 90
      @test stirlings2(6, 4) == 65
      @test stirlings2(6, 5) == 15
      @test stirlings2(6, 6) == 1
      @test stirlings2(big"26", 10) == 13199555372846848005

      # bell
      @test bellnum.(0:10) == [
           1
           1
           2
           5
          15
          52
         203
         877
        4140
       21147
      115975
      ]

      @test bellnum(42) == parse(BigInt, "35742549198872617291353508656626642567")
      @test_throws DomainError(-1) bellnum(-1)

end

#Special named numbers and symbols

export bellnum,
    catalannum,
    lobbnum,
    narayana,
    fibonaccinum,
    jacobisymbol,
    lassallenum,
    legendresymbol,
    lucasnum,
    stirlings1,
    stirlings2

"""
    bellnum(n)

Compute the ``n``th Bell number.
"""
function bellnum(n::Integer)
    if n < 0
        throw(DomainError(n))
    elseif n < 2
        return 1
    end
    list = Vector{BigInt}(undef, n)
    list[1] = 1
    for i = 2:n
        for j = 1:i - 2
            list[i - j - 1] += list[i - j]
        end
        list[i] = list[1] + list[i - 1]
    end
    return list[n]
end


"""
    catalannum(n)

Compute the ``n``th Catalan number.
"""
function catalannum(bn::Integer)
    if bn < 0
        throw(DomainError(bn, "n must be nonnegative"))
    else
        n = BigInt(bn)
    end
    div(binomial(2*n, n), (n + 1))
end

"""
    lobbnum(m,n)

Compute the Lobb number `L(m,n)`, or the generalised Catalan number given by ``\\frac{2m+1}{m+n+1} \\binom{2n}{m+n}``.
Wikipedia : https://en.wikipedia.org/wiki/Lobb_number
"""
function lobbnum(bm::Integer,bn::Integer)
    if !(0 <= bm <= bn)
        throw(DomainError("m and n must be non-negative"))
    else
        m = BigInt(bm)
        n = BigInt(bn)
    end
    div(binomial(2*n, m + n)*(2*m + 1), (m + n + 1))
end

"""
    narayana(n,k)

Compute the Narayana number `N(n,k)` given by ``\\frac{1}{n}\\binom{n}{k}\\binom{n}{k-1}``
Wikipedia : https://en.wikipedia.org/wiki/Narayana_number
"""
function narayana(bn::Integer,bk::Integer)
    if !(1 <= bk <= bn)
        throw(DomainError("Domain is 1 <= k <= n"))
    else
        n = BigInt(bn)
        k = BigInt(bk)
    end
    div(binomial(n, k)*binomial(n, k - 1) , n)
end

function fibonaccinum(n::Integer)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    end
    z = Ref{BigInt}(0)
    ccall((:__gmpz_fib_ui, :libgmp), Cvoid, (Ref{BigInt}, UInt), z, UInt(n))
    return z[]
end


function jacobisymbol(a::Integer, b::Integer)
    ba = Ref{BigInt}(a)
    bb = Ref{BigInt}(b)
    return ccall((:__gmpz_jacobi, :libgmp), Cint, (Ref{BigInt}, Ref{BigInt}), ba, bb)
end

"""
    lassallenum(n)

Compute the ``n``th entry in Lassalle's sequence, OEIS entry A180874.
"""
function lassallenum(m::Integer)
    A = ones(BigInt, m)
    for n = 2:m
        A[n] = (-1)^(n-1) * (catalannum(n) + sum(j->(-1)^j*binomial(2n-1, 2j-1)*A[j]*catalannum(n-j), 1:n-1))
    end
    A[m]
end

function legendresymbol(a::Integer, b::Integer)
    ba = Ref{BigInt}(a)
    bb = Ref{BigInt}(b)
    return ccall((:__gmpz_legendre, :libgmp), Cint, (Ref{BigInt}, Ref{BigInt}), ba, bb)
end

function lucasnum(n::Integer)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    end
    z = Ref{BigInt}(0)
    ccall((:__gmpz_lucnum_ui, :libgmp), Cvoid, (Ref{BigInt}, UInt), z, UInt(n))
    return z[]
end

function stirlings1(n::Int, k::Int, signed::Bool=false)
    if signed == true
        return (-1)^(n - k) * stirlings1(n, k)
    end

    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    elseif n == k == 0
        return 1
    elseif n == 0 || k == 0
        return 0
    elseif n == k
        return 1
    elseif k == 1
        return factorial(n-1)
    elseif k == n - 1
        return binomial(n, 2)
    elseif k == n - 2
        return div((3 * n - 1) * binomial(n, 3), 4)
    elseif k == n - 3
        return binomial(n, 2) * binomial(n, 4)
    end

    return (n - 1) * stirlings1(n - 1, k) + stirlings1(n - 1, k - 1)
end

function stirlings2(n::Int, k::Int)
    if n < 0
        throw(DomainError(n, "n must be nonnegative"))
    elseif n == k == 0
        return 1
    elseif n == 0 || k == 0
        return 0
    elseif k == n - 1
        return binomial(n, 2)
    elseif k == 2
        return 2^(n-1) - 1
    end

    return k * stirlings2(n - 1, k) + stirlings2(n - 1, k - 1)
end

# Multinomial theorem
# https://en.wikipedia.org/wiki/Multinomial_theorem

export multiexponents

struct MultiExponents{T}
    c::T
    nterms::Int
end

# Standard stars and bars:
# https://en.wikipedia.org/wiki/Stars_and_bars_(combinatorics)
function Base.iterate(m::MultiExponents, s = nothing)
    next = s === nothing ? iterate(m.c) : iterate(m.c, s)
    next === nothing && return
    stars, ss = next

    # stars minus their consecutive
    # position becomes their index
    result = zeros(Int, m.nterms)
    for (i, s) in enumerate(stars)
        result[s-i+1] += 1
    end

    result, ss
end

Base.length(m::MultiExponents) = length(m.c)
Base.eltype(::Type{MultiExponents{T}}) where {T} = Vector{Int}

"""
    multiexponents(m, n)

Returns the exponents in the multinomial expansion (x₁ + x₂ + ... + xₘ)ⁿ.

For example, the expansion (x₁ + x₂ + x₃)² = x₁² + x₁x₂ + x₁x₃ + ...
has the exponents:

```julia-repl
julia> collect(multiexponents(3, 2))
6-element Vector{Vector{Int64}}:
 [2, 0, 0]
 [1, 1, 0]
 [1, 0, 1]
 [0, 2, 0]
 [0, 1, 1]
 [0, 0, 2]
```
"""
function multiexponents(m, n)
    # number of stars and bars = m+n-1
    c = combinations(1:m+n-1, n)

    MultiExponents(c, m)
end

using OffsetArrays

struct Permutations{T}
    data::T
    length::Int
end

@testset "permutations" begin
    @test collect(permutations("abc")) == Any[['a', 'b', 'c'], ['a', 'c', 'b'], ['b', 'a', 'c'],
        ['b', 'c', 'a'], ['c', 'a', 'b'], ['c', 'b', 'a']]

    @test collect(Iterators.filter(x -> (iseven(x[1])), permutations([1, 2, 3]))) == Any[[2, 1, 3], [2, 3, 1]]
    @test collect(Iterators.filter(x -> (iseven(x[3])), permutations([1, 2, 3]))) == Any[[1, 3, 2], [3, 1, 2]]

    @test length(permutations(0)) == 1

    @test collect(permutations("abc", 4)) == Any[]
    @test collect(permutations("abc", 2)) == Any[['a', 'b'], ['a', 'c'], ['b', 'a'],
        ['b', 'c'], ['c', 'a'], ['c', 'b']]
    @test collect(permutations(1:5, 1)) == [[x] for x in 1:5]
    @test collect(permutations("abc", 0)) == [Char[]]
    @test collect(permutations("abc", -1)) == Any[]
    @test collect(permutations("", 1)) == Any[]
    @test collect(permutations("", 0)) == [Char[]]
    @test collect(permutations("", -1)) == Any[]

    @inferred first(permutations("abc", 2))

    # check if all works for empty collections and various t
    @test collect(permutations([], -1)) == Any[]
    @test collect(permutations([], 0)) == [Any[]]
    @test collect(permutations([], 1)) == Any[]
    
    @testset "permutation lengths" begin
        expected_lengths = [1, 5, 20, 60, 120, 120]
        ks = 0:5
        for (el, k) in zip(expected_lengths, ks)
            @test length(permutations(1:5, k)) == el
        end
    end

    @testset "permutation eltype" begin
        @test eltype(permutations(1:5)) == Vector{Int64}
        @test eltype(permutations("abc")) == Vector{Char}
        @test eltype(permutations([1.0, 2.0])) == Vector{Float64}
        @test eltype(permutations([big(x) for x in 1:3])) == Vector{BigInt}
    end

    @testset "offset arrays" begin
        v = [1, 2, 3]
        ov = OffsetArray(v, -1:1)
        @test collect(permutations(v, 2)) == collect(permutations(ov, 2))

        # This test gets stuck in an infinite loop
        @test collect(permutations(v)) == collect(permutations(ov))
    end

    # multiset_permutations
    @test collect(multiset_permutations("aabc", 5)) == Any[]
    @test collect(multiset_permutations("aabc", 2)) == Any[['a', 'a'], ['a', 'b'], ['a', 'c'], ['b', 'a'],
        ['b', 'c'], ['c', 'a'], ['c', 'b']]
    @test collect(multiset_permutations("aabc", 0)) == Any[Char[]]
    @test collect(multiset_permutations("aabc", -1)) == Any[]
    @test collect(multiset_permutations("", 1)) == Any[]
    @test collect(multiset_permutations("", 0)) == Any[Char[]]
    @test collect(multiset_permutations("", -1)) == Any[]
    @test length(multiset_permutations("aaaaaaaaaaaaaaaaaaaaab", 21)) == 22

    #nthperm!
    for n = 0:7, k = 1:factorial(n)
        p = nthperm!([1:n;], k)
        @test isperm(p)
        @test nthperm(p) == k
    end
    #Euler Problem #24
    @test nthperm!([0:9;], 1000000) == [2, 7, 8, 3, 9, 1, 5, 4, 6, 0]

    @test_throws ArgumentError nthperm([0, 1, 2], 0)
    @test nthperm([0, 1, 2], 1) == [0, 1, 2]
    @test nthperm([0, 1, 2], 3) == [1, 0, 2]
    @test nthperm([0, 1, 2], 6) == [2, 1, 0]
    @test_throws ArgumentError nthperm([0, 1, 2], 7)

    @test_throws ArgumentError nthperm([0:20;], big(0))
    @test nthperm([0:20;], big(1)) == [0:20;]
    @test nthperm([0:20;], factorial(big(20))) == [0; 20:-1:1]
    @test nthperm([0:20;], factorial(big(21))) == [20:-1:0;]
    @test_throws ArgumentError nthperm([0:20;], factorial(big(21)) + 1)

    # Immutable AbstractArrays
    @test nthperm(1:5, 1) == [1, 2, 3, 4, 5]

    @test_throws ArgumentError parity([0])
    @test_throws ArgumentError parity([1, 2, 3, 3])
    @test levicivita([1, 1, 2, 3]) == 0
    @test levicivita([1]) == 1 && parity([1]) == 0
    @test map(levicivita, collect(permutations([1, 2, 3]))) == [1, -1, -1, 1, 1, -1]
    @test let p = [3, 4, 6, 10, 5, 2, 1, 7, 8, 9]
        levicivita(p) == 1 && parity(p) == 0
    end
    @test let p = [4, 3, 6, 10, 5, 2, 1, 7, 8, 9]
        levicivita(p) == -1 && parity(p) == 1
    end

    @test Combinatorics.nsetpartitions(-1) == 0
    @test collect(permutations([])) == [[]]

end

# Getting started

A combinatorics library for Julia, focusing mostly (as of now) on enumerative combinatorics and permutations. As overflows are expected even for low values, most of the functions always return BigInt, and are marked as such below.

## Installation

In the Julia REPL, type `]add Combinatorics` and then `using Combinatorics` to access the functions listed below.

## Index

```@index
```

# API reference

## Combinations

```@autodocs
Modules = [Combinatorics]
Pages   = ["combinations.jl"]
```

## Factorials

```@autodocs
Modules = [Combinatorics]
Pages   = ["factorials.jl"]
```

## Multinomials

```@autodocs
Modules = [Combinatorics]
Pages   = ["multinomials.jl"]
```

## Numbers

```@autodocs
Modules = [Combinatorics]
Pages   = ["numbers.jl"]
```

## Partitions

```@autodocs
Modules = [Combinatorics]
Pages   = ["partitions.jl"]
```

## Permutations

```@autodocs
Modules = [Combinatorics]
Pages   = ["permutations.jl"]
```

## Young diagrams

```@autodocs
Modules = [Combinatorics]
Pages   = ["youngdiagrams.jl"]
```
